#ifndef QUEUE_SEEN
#define QUEUE_SEEN


// A Queue is a linked list implementation of a queue, used for BFS.

class Configuration;
class ConfigurationList;

class Queue
{
    ConfigurationList   *head;              // the configuration that will be dequeued next
    ConfigurationList   *tail;              // the configuration that was just enqueued
    
public:

                        Queue();
                        ~Queue();
                        
    void                enqueue(Configuration *config);
    Configuration       *dequeue();

    bool                empty();
    bool                isPresent(Configuration *match);
};


#endif
